import { DecoderError, DecoderSuccess } from 'ts-decoders';
import { ComposeDecoderOptions } from './util';
/** Convenience function for building a DecoderSuccess result */
export declare function ok<T>(value: T): DecoderSuccess<T>;
/** Convenience function for building a simple DecoderError[] result */
export declare function err(
  input: any,
  type: string,
  errorMsg: string,
  decoderName: string,
  options?: ComposeDecoderOptions,
): DecoderError[];
/**
 * Builds the `DecoderError#location` property given the child error's
 * location and the current key.
 */
export declare function errorLocation(
  key: string | number,
  childLocation: string,
): string;
// # sourceMappingURL=_util.d.ts.map
