import { AsyncDecoder, Decoder } from 'ts-decoders';
import { ComposeDecoderOptions } from './util';
export declare type ArrayDecoderOptions = ComposeDecoderOptions;
/**
 * Can be used to make sure an input is an array. If an optional decoder
 * argument is provided, that decoder will be used to process all of the
 * input's elements.
 *
 * Options:
 * - If you pass an `allErrors: true` option as well as any AsyncDecoders
 *   as arguments, then `arrayD()` will create a new AsyncDecoder which
 *   decodes each index of the input array in parallel.
 *
 * Related:
 * - tupleD
 * - dictionaryD
 */
export declare function arrayD<R = any>(
  options?: ArrayDecoderOptions,
): Decoder<R[]>;
export declare function arrayD<R>(
  decoder: Decoder<R>,
  options?: ArrayDecoderOptions,
): Decoder<R[]>;
export declare function arrayD<R>(
  decoder: AsyncDecoder<R>,
  options?: ArrayDecoderOptions,
): AsyncDecoder<R[]>;
// # sourceMappingURL=array.d.ts.map
