import { Decoder } from 'ts-decoders';
import { SimpleDecoderOptions } from './util';
export declare type InstanceOfDecoderOptions = SimpleDecoderOptions;
/**
 * Accepts a javascript constructor argument (`class`) and creates a
 * decoder which verifies that its input is an `instanceof` the
 * provided constructor.
 */
export declare function instanceOfD<T extends new (...args: any) => any>(
  clazz: T,
  options?: InstanceOfDecoderOptions,
): Decoder<InstanceType<T>>;
// # sourceMappingURL=instanceOf.d.ts.map
