import { AsyncDecoder, Decoder } from 'ts-decoders';
export interface LazyDecoderOptions {
  decoderName?: string;
  promise?: boolean;
}
/**
 * Recieves a function which returns a decoder and creates a new
 * decoder which calls this function on each `.decode()` call and
 * uses the returned decoder to decode it's input. A common use case
 * for this decoder is to decode recursive data structures.
 * Alternate names for this decoder could be: recursive.
 */
export declare function lazyD<R, I = any>(
  decoderFn: (value: I) => Decoder<R, I>,
  options?: LazyDecoderOptions & {
    promise?: false;
  },
): Decoder<R, I>;
export declare function lazyD<R, I = any>(
  decoderFn: (
    value: I,
  ) =>
    | Decoder<R, I>
    | AsyncDecoder<R, I>
    | Promise<Decoder<R, I> | AsyncDecoder<R, I>>,
  options: LazyDecoderOptions & {
    promise: true;
  },
): AsyncDecoder<R, I>;
// # sourceMappingURL=lazy.d.ts.map
