import { AsyncDecoder, Decoder } from 'ts-decoders';
import { SimpleDecoderOptions } from './util';
export declare type NullableDecoderOptions = SimpleDecoderOptions;
/**
 * Accepts a decoder and returns a new decoder which accepts either the
 * original decoder's value or `null`.
 *
 * Related:
 * - undefinableD
 * - optionalD
 */
export declare function nullableD<R, I>(
  decoder: Decoder<R, I>,
  options?: NullableDecoderOptions,
): Decoder<R | null, I>;
export declare function nullableD<R, I>(
  decoder: AsyncDecoder<R, I>,
  options?: NullableDecoderOptions,
): AsyncDecoder<R | null, I>;
// # sourceMappingURL=nullable.d.ts.map
