import { AsyncDecoder, Decoder } from 'ts-decoders';
import { SimpleDecoderOptions } from './util';
export declare type OptionalDecoderOptions = SimpleDecoderOptions;
/**
 * Accepts a decoder and returns a new decoder which accepts
 * either the original decoder's value or `null` or `undefined`.
 *
 * Related:
 * - nullableD
 * - undefinableD
 */
export declare function optionalD<R, I>(
  decoder: Decoder<R, I>,
  options?: OptionalDecoderOptions,
): Decoder<R | null | undefined, I>;
export declare function optionalD<R, I>(
  decoder: AsyncDecoder<R, I>,
  options?: OptionalDecoderOptions,
): AsyncDecoder<R | null | undefined, I>;
// # sourceMappingURL=optional.d.ts.map
