import { AsyncDecoder, Decoder } from 'ts-decoders';
import { SimpleDecoderOptions } from './util';
export declare type UndefinableDecoderOptions = SimpleDecoderOptions;
/**
 * Accepts a decoder and returns a new decoder which accepts
 * either the original decoder's value or `undefined`.
 *
 * Related:
 * - nullableD
 * - optionalD
 */
export declare function undefinableD<R, I>(
  decoder: Decoder<R, I>,
  options?: UndefinableDecoderOptions,
): Decoder<R | undefined, I>;
export declare function undefinableD<R, I>(
  decoder: AsyncDecoder<R, I>,
  options?: UndefinableDecoderOptions,
): AsyncDecoder<R | undefined, I>;
// # sourceMappingURL=undefinable.d.ts.map
