import { DecoderError, DecoderResult, DecoderSuccess } from 'ts-decoders';
export interface SimpleDecoderOptions {
  decoderName?: string;
  data?: any;
  errorMsg?: DecoderErrorMsgArg;
}
export interface ComposeDecoderOptions extends SimpleDecoderOptions {
  allErrors?: boolean;
}
export declare type DecoderErrorMsgArg =
  | string
  | ((input: unknown, errors: DecoderError[]) => DecoderError | DecoderError[]);
export declare function applyOptionsToDecoderErrors(
  input: any,
  errors: DecoderError | DecoderError[],
  options: ComposeDecoderOptions | undefined,
): DecoderError[];
/**
 * Resolves the provided DecoderResults, returning the first
 * DecoderSuccess or all the DecoderErrors.
 */
export declare function raceToDecoderSuccess<T>(
  promises: Array<Promise<DecoderResult<T>>>,
): Promise<DecoderSuccess<T> | DecoderError[]>;
// # sourceMappingURL=util.d.ts.map
