(function(global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined'
    ? factory(exports, require('ts-decoders'))
    : typeof define === 'function' && define.amd
    ? define(['exports', 'ts-decoders'], factory)
    : ((global = global || self),
      factory((global.tsDecodersDecoders = {}), global.tsDecoders));
})(this, function(exports, tsDecoders) {
  'use strict';

  /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

  var __assign = function() {
    __assign =
      Object.assign ||
      function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
      };
    return __assign.apply(this, arguments);
  };

  function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function(resolve, reject) {
      function fulfilled(value) {
        try {
          step(generator.next(value));
        } catch (e) {
          reject(e);
        }
      }
      function rejected(value) {
        try {
          step(generator['throw'](value));
        } catch (e) {
          reject(e);
        }
      }
      function step(result) {
        result.done
          ? resolve(result.value)
          : new P(function(resolve) {
              resolve(result.value);
            }).then(fulfilled, rejected);
      }
      step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
  }

  function __generator(thisArg, body) {
    var _ = {
        label: 0,
        sent: function() {
          if (t[0] & 1) throw t[1];
          return t[1];
        },
        trys: [],
        ops: [],
      },
      f,
      y,
      t,
      g;
    return (
      (g = { next: verb(0), throw: verb(1), return: verb(2) }),
      typeof Symbol === 'function' &&
        (g[Symbol.iterator] = function() {
          return this;
        }),
      g
    );
    function verb(n) {
      return function(v) {
        return step([n, v]);
      };
    }
    function step(op) {
      if (f) throw new TypeError('Generator is already executing.');
      while (_)
        try {
          if (
            ((f = 1),
            y &&
              (t =
                op[0] & 2
                  ? y['return']
                  : op[0]
                  ? y['throw'] || ((t = y['return']) && t.call(y), 0)
                  : y.next) &&
              !(t = t.call(y, op[1])).done)
          )
            return t;
          if (((y = 0), t)) op = [op[0] & 2, t.value];
          switch (op[0]) {
            case 0:
            case 1:
              t = op;
              break;
            case 4:
              _.label++;
              return { value: op[1], done: false };
            case 5:
              _.label++;
              y = op[1];
              op = [0];
              continue;
            case 7:
              op = _.ops.pop();
              _.trys.pop();
              continue;
            default:
              if (
                !((t = _.trys), (t = t.length > 0 && t[t.length - 1])) &&
                (op[0] === 6 || op[0] === 2)
              ) {
                _ = 0;
                continue;
              }
              if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                _.label = op[1];
                break;
              }
              if (op[0] === 6 && _.label < t[1]) {
                _.label = t[1];
                t = op;
                break;
              }
              if (t && _.label < t[2]) {
                _.label = t[2];
                _.ops.push(op);
                break;
              }
              if (t[2]) _.ops.pop();
              _.trys.pop();
              continue;
          }
          op = body.call(thisArg, _);
        } catch (e) {
          op = [6, e];
          y = 0;
        } finally {
          f = t = 0;
        }
      if (op[0] & 5) throw op[1];
      return { value: op[0] ? op[1] : void 0, done: true };
    }
  }

  function applyOptionsToDecoderErrors(input, errors, options) {
    if (errors instanceof tsDecoders.DecoderError) {
      errors = [errors];
    }
    if (!options) return errors;
    if (options.decoderName !== undefined && options.data !== undefined) {
      Array.from(errors.values()).forEach(function(error) {
        error.data = options.data;
        error.decoderName = options.decoderName;
      });
    } else if (options.decoderName) {
      Array.from(errors.values()).forEach(function(error) {
        error.decoderName = options.decoderName;
      });
    } else if (options.data !== undefined) {
      Array.from(errors.values()).forEach(function(error) {
        error.data = options.data;
      });
    }
    if (typeof options.errorMsg === 'function') {
      errors = options.errorMsg(input, errors);
      if (errors instanceof tsDecoders.DecoderError) errors = [errors];
    } else if (options.errorMsg) {
      Array.from(errors.values()).forEach(function(error) {
        error.message = options.errorMsg;
        return error;
      });
    }
    if (errors.length === 0) {
      throw new Error(
        'Provided DecoderError function must return ' +
          'an array of DecoderErrors with length greater than 0.',
      );
    }
    return errors;
  }
  function _raceToDecoderSuccess(promises, errors) {
    if (errors === void 0) {
      errors = [];
    }
    return __awaiter(this, void 0, void 0, function() {
      var indexedPromises, res;
      return __generator(this, function(_a) {
        switch (_a.label) {
          case 0:
            if (promises.length === 0) return [2 /*return*/, errors];
            indexedPromises = promises.map(function(promise, index) {
              return promise.then(function(value) {
                return [index, value];
              });
            });
            return [4 /*yield*/, Promise.race(indexedPromises)];
          case 1:
            res = _a.sent();
            if (tsDecoders.areDecoderErrors(res[1])) {
              promises.splice(res[0], 1);
              errors.push.apply(errors, res[1]);
              return [2 /*return*/, _raceToDecoderSuccess(promises, errors)];
            }
            return [2 /*return*/, res[1]];
        }
      });
    });
  }
  /**
   * Resolves the provided DecoderResults, returning the first
   * DecoderSuccess or all the DecoderErrors.
   */
  function raceToDecoderSuccess(promises) {
    return _raceToDecoderSuccess(promises);
  }

  var decoderName = 'anyOfD';
  function childErrors(input, children) {
    return children.map(function(child, index) {
      return new tsDecoders.DecoderError(
        input,
        'anyOf ' + index,
        'invalid value',
        {
          child: child,
        },
      );
    });
  }
  function anyOfD(decoders, provOptions) {
    var _this = this;
    if (provOptions === void 0) {
      provOptions = {};
    }
    var options = __assign({}, provOptions, {
      decoderName: provOptions.decoderName || decoderName,
      allErrors: true,
    });
    var hasAsyncDecoder = decoders.some(function(decoder) {
      return decoder instanceof tsDecoders.AsyncDecoder;
    });
    if (hasAsyncDecoder) {
      if (options.decodeInParallel) {
        return new tsDecoders.AsyncDecoder(function(input) {
          return __awaiter(_this, void 0, void 0, function() {
            var promises, result;
            var _this = this;
            return __generator(this, function(_a) {
              switch (_a.label) {
                case 0:
                  promises = decoders.map(function(decoder) {
                    return __awaiter(_this, void 0, void 0, function() {
                      return __generator(this, function(_a) {
                        switch (_a.label) {
                          case 0:
                            return [4 /*yield*/, decoder.decode(input)];
                          case 1:
                            return [2 /*return*/, _a.sent()];
                        }
                      });
                    });
                  });
                  return [4 /*yield*/, raceToDecoderSuccess(promises)];
                case 1:
                  result = _a.sent();
                  if (result instanceof tsDecoders.DecoderSuccess)
                    return [2 /*return*/, result];
                  return [
                    2 /*return*/,
                    applyOptionsToDecoderErrors(
                      input,
                      childErrors(input, result),
                      options,
                    ),
                  ];
              }
            });
          });
        });
      }
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var errors, _i, decoders_1, decoder, result;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                errors = [];
                (_i = 0), (decoders_1 = decoders);
                _a.label = 1;
              case 1:
                if (!(_i < decoders_1.length)) return [3 /*break*/, 4];
                decoder = decoders_1[_i];
                return [4 /*yield*/, decoder.decode(input)];
              case 2:
                result = _a.sent();
                if (result instanceof tsDecoders.DecoderSuccess)
                  return [2 /*return*/, result];
                errors.push.apply(errors, result);
                _a.label = 3;
              case 3:
                _i++;
                return [3 /*break*/, 1];
              case 4:
                return [
                  2 /*return*/,
                  applyOptionsToDecoderErrors(
                    input,
                    childErrors(input, errors),
                    options,
                  ),
                ];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      var errors = [];
      for (var _i = 0, decoders_2 = decoders; _i < decoders_2.length; _i++) {
        var decoder = decoders_2[_i];
        var result = decoder.decode(input);
        if (result instanceof tsDecoders.DecoderSuccess) return result;
        errors.push.apply(errors, result);
      }
      return applyOptionsToDecoderErrors(
        input,
        childErrors(input, errors),
        options,
      );
    });
  }

  /** Convenience function for building a DecoderSuccess result */
  function ok(value) {
    return new tsDecoders.DecoderSuccess(value);
  }
  /** Convenience function for building a simple DecoderError[] result */
  function err(input, type, errorMsg, decoderName, options) {
    return applyOptionsToDecoderErrors(
      input,
      new tsDecoders.DecoderError(input, type, errorMsg, {
        decoderName: decoderName,
      }),
      options,
    );
  }
  /**
   * Builds the `DecoderError#location` property given the child error's
   * location and the current key.
   */
  function errorLocation(key, childLocation) {
    // simple check to see if we can render the key using dot (`.`) notation
    var keyIsValidDotAccessor =
      typeof key === 'string' && /^[a-zA-Z]+$/.test(key);
    // prettier-ignore : prettier makes this harder to read
    var location = keyIsValidDotAccessor
      ? key.toString()
      : // if we can't render the key using dot notation, is it a string?
      typeof key === 'string'
      ? '["' + key + '"]'
      : '[' + key + ']';
    // check to see if the previous nested child location was rendered using dot
    // notation. A '[' as the first character indicates that it was not.
    // `undefined` as the first character means the child location === ''.
    // If it was, add the dot (`.`) in.
    return ['[', undefined].includes(childLocation[0])
      ? location.concat(childLocation)
      : location + '.' + childLocation;
  }

  /**
   * Creates a decoder which always returns `DecoderSuccess` with
   * whatever input value is provided to it.
   */
  function anyD() {
    return new tsDecoders.Decoder(function(value) {
      return ok(value);
    });
  }

  var decoderName$1 = 'arrayD';
  function nonArrayError(input, options) {
    if (options === void 0) {
      options = {};
    }
    return applyOptionsToDecoderErrors(
      input,
      new tsDecoders.DecoderError(input, 'invalid type', 'must be an array'),
      options,
    );
  }
  function childError(input, child, key) {
    var location = errorLocation(key, child.location);
    return new tsDecoders.DecoderError(
      input,
      'invalid element',
      'invalid element [' + key + '] > ' + child.message,
      {
        child: child,
        location: location,
        key: key,
      },
    );
  }
  function arrayD(decoder, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    options = __assign({}, options, {
      decoderName: options.decoderName || decoderName$1,
    });
    if (
      !(
        decoder instanceof tsDecoders.Decoder ||
        decoder instanceof tsDecoders.AsyncDecoder
      )
    ) {
      return new tsDecoders.Decoder(function(input) {
        return Array.isArray(input)
          ? ok(input.slice())
          : nonArrayError(input, options);
      });
    }
    if (decoder instanceof tsDecoders.AsyncDecoder) {
      if (options.allErrors) {
        return new tsDecoders.AsyncDecoder(function(input) {
          return __awaiter(_this, void 0, void 0, function() {
            var hasError, results, errors_1, elements;
            var _this = this;
            return __generator(this, function(_a) {
              switch (_a.label) {
                case 0:
                  if (!Array.isArray(input))
                    return [2 /*return*/, nonArrayError(input, options)];
                  hasError = false;
                  return [
                    4 /*yield*/,
                    Promise.all(
                      input.map(function(item) {
                        return __awaiter(_this, void 0, void 0, function() {
                          var result;
                          return __generator(this, function(_a) {
                            switch (_a.label) {
                              case 0:
                                return [4 /*yield*/, decoder.decode(item)];
                              case 1:
                                result = _a.sent();
                                if (
                                  !hasError &&
                                  tsDecoders.areDecoderErrors(result)
                                ) {
                                  hasError = true;
                                }
                                return [2 /*return*/, result];
                            }
                          });
                        });
                      }),
                    ),
                  ];
                case 1:
                  results = _a.sent();
                  if (hasError) {
                    errors_1 = [];
                    results.forEach(function(result, index) {
                      if (tsDecoders.areDecoderErrors(result)) {
                        errors_1.push.apply(
                          errors_1,
                          result.map(function(error) {
                            return childError(input, error, index);
                          }),
                        );
                      }
                    });
                    return [
                      2 /*return*/,
                      applyOptionsToDecoderErrors(input, errors_1, options),
                    ];
                  }
                  elements = results.map(function(result) {
                    return result.value;
                  });
                  return [2 /*return*/, ok(elements)];
              }
            });
          });
        });
      }
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var elements, index, _i, input_1, el, result, errors;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                if (!Array.isArray(input))
                  return [2 /*return*/, nonArrayError(input, options)];
                elements = [];
                index = -1;
                (_i = 0), (input_1 = input);
                _a.label = 1;
              case 1:
                if (!(_i < input_1.length)) return [3 /*break*/, 4];
                el = input_1[_i];
                index++;
                return [4 /*yield*/, decoder.decode(el)];
              case 2:
                result = _a.sent();
                if (tsDecoders.areDecoderErrors(result)) {
                  errors = result.map(function(error) {
                    return childError(input, error, index);
                  });
                  return [
                    2 /*return*/,
                    applyOptionsToDecoderErrors(input, errors, options),
                  ];
                }
                elements.push(result.value);
                _a.label = 3;
              case 3:
                _i++;
                return [3 /*break*/, 1];
              case 4:
                return [2 /*return*/, ok(elements)];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      if (!Array.isArray(input)) return nonArrayError(input, options);
      var elements = [];
      var index = -1;
      var allErrors = [];
      for (var _i = 0, input_2 = input; _i < input_2.length; _i++) {
        var el = input_2[_i];
        index++;
        var result = decoder.decode(el);
        if (tsDecoders.areDecoderErrors(result)) {
          var errors = result.map(function(error) {
            return childError(input, error, index);
          });
          if (!options.allErrors) {
            return applyOptionsToDecoderErrors(input, errors, options);
          }
          allErrors.push.apply(allErrors, errors);
          continue;
        }
        elements.push(result.value);
      }
      if (allErrors.length > 0) {
        return applyOptionsToDecoderErrors(input, allErrors, options);
      }
      return ok(elements);
    });
  }

  /** Can be used to verify that an unknown value is a `boolean`. */
  function booleanD(options) {
    if (options === void 0) {
      options = {};
    }
    return new tsDecoders.Decoder(function(value) {
      return typeof value === 'boolean'
        ? ok(value)
        : err(value, 'invalid type', 'must be a boolean', 'booleanD', options);
    });
  }

  var decoderName$2 = 'chainOfD';
  function fromChildErrors(input, children) {
    return children.map(function(child) {
      return new tsDecoders.DecoderError(input, child.type, child.message, {
        decoderName: decoderName$2,
        child: child,
      });
    });
  }
  function chainOfD(a, b, c, d, e, f, o) {
    var _this = this;
    var options;
    var decoders = [];
    if (Array.isArray(a)) decoders.push.apply(decoders, a);
    else decoders.push(a);
    [b, c, d, e, f, o].forEach(function(val) {
      if (isDecoder(val)) decoders.push(val);
      else if (val) options = val;
    });
    options = options || {};
    options = __assign({}, options, {
      decoderName: options.decoderName || decoderName$2,
    });
    if (
      decoders.some(function(decoder) {
        return decoder instanceof tsDecoders.AsyncDecoder;
      })
    ) {
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var result, _i, decoders_1, decoder;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                result = ok(input);
                (_i = 0), (decoders_1 = decoders);
                _a.label = 1;
              case 1:
                if (!(_i < decoders_1.length)) return [3 /*break*/, 4];
                decoder = decoders_1[_i];
                if (!(result instanceof tsDecoders.DecoderSuccess))
                  return [3 /*break*/, 4];
                return [4 /*yield*/, decoder.decode(result.value)];
              case 2:
                result = _a.sent();
                _a.label = 3;
              case 3:
                _i++;
                return [3 /*break*/, 1];
              case 4:
                if (tsDecoders.areDecoderErrors(result)) {
                  return [
                    2 /*return*/,
                    applyOptionsToDecoderErrors(
                      input,
                      fromChildErrors(input, result),
                      options,
                    ),
                  ];
                }
                return [2 /*return*/, result];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      var result = decoders.reduce(function(prev, curr) {
        return prev instanceof tsDecoders.DecoderSuccess
          ? curr.decode(prev.value)
          : prev;
      }, ok(input));
      if (tsDecoders.areDecoderErrors(result)) {
        return applyOptionsToDecoderErrors(
          input,
          fromChildErrors(input, result),
          options,
        );
      }
      return result;
    });
  }
  function isDecoder(a) {
    return (
      a instanceof tsDecoders.Decoder || a instanceof tsDecoders.AsyncDecoder
    );
  }

  function constantD(constant) {
    return new tsDecoders.Decoder(function() {
      return ok(constant);
    });
  }

  var decoderName$3 = 'dictionaryD';
  function childKeyError(input, child, key) {
    var location = errorLocation(key, '');
    return new tsDecoders.DecoderError(
      input,
      'invalid key',
      'invalid key ["' + key + '"] > ' + child.message,
      {
        decoderName: decoderName$3,
        child: child,
        location: location,
        key: key,
      },
    );
  }
  function childValueError(input, child, key) {
    var location = errorLocation(key, child.location);
    return new tsDecoders.DecoderError(
      input,
      'invalid key value',
      'invalid value for key ["' + key + '"] > ' + child.message,
      {
        decoderName: decoderName$3,
        child: child,
        location: location,
        key: key,
      },
    );
  }
  function asyncDecodeKey(input, decoder, key) {
    return __awaiter(this, void 0, void 0, function() {
      var keyResult;
      return __generator(this, function(_a) {
        switch (_a.label) {
          case 0:
            return [4 /*yield*/, decoder.decode(key)];
          case 1:
            keyResult = _a.sent();
            if (tsDecoders.areDecoderErrors(keyResult)) {
              return [
                2 /*return*/,
                keyResult.map(function(error) {
                  return childKeyError(input, error, key);
                }),
              ];
            }
            return [2 /*return*/, keyResult];
        }
      });
    });
  }
  function asyncDecodeValue(input, decoder, value, key) {
    return __awaiter(this, void 0, void 0, function() {
      var valueResult;
      return __generator(this, function(_a) {
        switch (_a.label) {
          case 0:
            return [4 /*yield*/, decoder.decode(value)];
          case 1:
            valueResult = _a.sent();
            if (tsDecoders.areDecoderErrors(valueResult)) {
              return [
                2 /*return*/,
                valueResult.map(function(error) {
                  return childValueError(input, error, key);
                }),
              ];
            }
            return [2 /*return*/, valueResult];
        }
      });
    });
  }
  function nonObjectError(input, options) {
    return applyOptionsToDecoderErrors(
      input,
      new tsDecoders.DecoderError(
        input,
        'invalid type',
        'must be a non-null object',
        {
          decoderName: decoderName$3,
        },
      ),
      options,
    );
  }
  function dictionaryD(decoder, optionalA, optionalB) {
    var _this = this;
    var keyDecoder;
    var options = {};
    if (optionalA) {
      if (
        optionalA instanceof tsDecoders.Decoder ||
        optionalA instanceof tsDecoders.AsyncDecoder
      ) {
        keyDecoder = optionalA;
      } else {
        options = optionalA;
      }
    }
    if (optionalB) {
      options = optionalB;
    }
    options = __assign({}, options, {
      decoderName: options.decoderName || decoderName$3,
    });
    if (
      decoder instanceof tsDecoders.AsyncDecoder ||
      keyDecoder instanceof tsDecoders.AsyncDecoder
    ) {
      if (options.allErrors) {
        return new tsDecoders.AsyncDecoder(function(input) {
          return __awaiter(_this, void 0, void 0, function() {
            var hasError, results, errors_1;
            var _this = this;
            return __generator(this, function(_a) {
              switch (_a.label) {
                case 0:
                  if (typeof input !== 'object' || input === null) {
                    return [2 /*return*/, nonObjectError(input, options)];
                  }
                  hasError = false;
                  return [
                    4 /*yield*/,
                    Promise.all(
                      Object.entries(input).map(function(_a) {
                        var entryKey = _a[0],
                          entryValue = _a[1];
                        return __awaiter(_this, void 0, void 0, function() {
                          var key, keyResult, valueResult;
                          return __generator(this, function(_b) {
                            switch (_b.label) {
                              case 0:
                                key = entryKey;
                                if (!keyDecoder) return [3 /*break*/, 2];
                                return [
                                  4 /*yield*/,
                                  asyncDecodeKey(input, keyDecoder, entryKey),
                                ];
                              case 1:
                                keyResult = _b.sent();
                                if (Array.isArray(keyResult)) {
                                  hasError = true;
                                  return [2 /*return*/, keyResult];
                                }
                                key = keyResult.value;
                                _b.label = 2;
                              case 2:
                                return [
                                  4 /*yield*/,
                                  asyncDecodeValue(
                                    input,
                                    decoder,
                                    entryValue,
                                    entryKey,
                                  ),
                                ];
                              case 3:
                                valueResult = _b.sent();
                                if (Array.isArray(valueResult)) {
                                  hasError = true;
                                  return [2 /*return*/, valueResult];
                                }
                                return [2 /*return*/, [key, valueResult.value]];
                            }
                          });
                        });
                      }),
                    ),
                  ];
                case 1:
                  results = _a.sent();
                  if (hasError) {
                    errors_1 = [];
                    results.forEach(function(result) {
                      if (result[0] instanceof tsDecoders.DecoderError) {
                        errors_1.push.apply(errors_1, result);
                      }
                    });
                    return [
                      2 /*return*/,
                      applyOptionsToDecoderErrors(input, errors_1, options),
                    ];
                  }
                  return [2 /*return*/, ok(Object.fromEntries(results))];
              }
            });
          });
        });
      }
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var resultObject,
            _i,
            _a,
            _b,
            entryKey,
            entryValue,
            key,
            keyResult,
            valueResult;
          return __generator(this, function(_c) {
            switch (_c.label) {
              case 0:
                if (typeof input !== 'object' || input === null) {
                  return [2 /*return*/, nonObjectError(input, options)];
                }
                resultObject = {};
                (_i = 0), (_a = Object.entries(input));
                _c.label = 1;
              case 1:
                if (!(_i < _a.length)) return [3 /*break*/, 6];
                (_b = _a[_i]), (entryKey = _b[0]), (entryValue = _b[1]);
                key = entryKey;
                if (!keyDecoder) return [3 /*break*/, 3];
                return [
                  4 /*yield*/,
                  asyncDecodeKey(input, keyDecoder, entryKey),
                ];
              case 2:
                keyResult = _c.sent();
                if (Array.isArray(keyResult)) {
                  return [
                    2 /*return*/,
                    applyOptionsToDecoderErrors(input, keyResult, options),
                  ];
                }
                key = keyResult.value;
                _c.label = 3;
              case 3:
                return [
                  4 /*yield*/,
                  asyncDecodeValue(input, decoder, entryValue, entryKey),
                ];
              case 4:
                valueResult = _c.sent();
                if (Array.isArray(valueResult)) {
                  return [
                    2 /*return*/,
                    applyOptionsToDecoderErrors(input, valueResult, options),
                  ];
                }
                resultObject[key] = valueResult.value;
                _c.label = 5;
              case 5:
                _i++;
                return [3 /*break*/, 1];
              case 6:
                return [2 /*return*/, ok(resultObject)];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      if (typeof input !== 'object' || input === null) {
        return nonObjectError(input, options);
      }
      var resultObject = {};
      var entries = Object.entries(input);
      var allErrors = [];
      var _loop_1 = function(entryKey, entryValue) {
        var key = entryKey;
        if (keyDecoder) {
          var keyResult = keyDecoder.decode(entryKey);
          if (tsDecoders.areDecoderErrors(keyResult)) {
            var errors = keyResult.map(function(error) {
              return childKeyError(input, error, entryKey);
            });
            if (options.allErrors) {
              allErrors.push.apply(allErrors, errors);
              return 'continue';
            }
            return {
              value: applyOptionsToDecoderErrors(input, errors, options),
            };
          }
          key = keyResult.value;
        }
        var valueResult = decoder.decode(entryValue);
        if (tsDecoders.areDecoderErrors(valueResult)) {
          var errors = valueResult.map(function(error) {
            return childValueError(input, error, entryKey);
          });
          if (options.allErrors) {
            allErrors.push.apply(allErrors, errors);
            return 'continue';
          }
          return { value: applyOptionsToDecoderErrors(input, errors, options) };
        }
        resultObject[key] = valueResult.value;
      };
      for (var _i = 0, entries_1 = entries; _i < entries_1.length; _i++) {
        var _a = entries_1[_i],
          entryKey = _a[0],
          entryValue = _a[1];
        var state_1 = _loop_1(entryKey, entryValue);
        if (typeof state_1 === 'object') return state_1.value;
      }
      if (allErrors.length > 0) {
        return applyOptionsToDecoderErrors(input, allErrors, options);
      }
      return ok(resultObject);
    });
  }

  var decoderName$4 = 'matchD';
  /**
   * Can be used to verify that an unknown value is a `string`
   * which conforms to the given `RegExp`.
   */
  function matchD(regex, options) {
    if (options === void 0) {
      options = {};
    }
    return new tsDecoders.Decoder(function(value) {
      if (typeof value !== 'string') {
        return err(
          value,
          'invalid type',
          'must be a string',
          decoderName$4,
          options,
        );
      }
      return regex.test(value)
        ? ok(value)
        : err(
            value,
            'invalid value',
            'must be a string matching the pattern "' + regex + '"',
            decoderName$4,
            options,
          );
    });
  }

  // this email regex is taken from this S.O. answer
  // https://dba.stackexchange.com/a/165923/191558
  // which in turn takes it from the HTML5 spec
  var emailRegex = /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
  /** Can be used to verify that an unknown value is an email address `string`. */
  function emailD(options) {
    if (options === void 0) {
      options = {};
    }
    return matchD(emailRegex, {
      data: options.data,
      decoderName: options.decoderName || 'emailD',
      errorMsg: options.errorMsg || 'must be a email address',
    });
  }

  function exactlyD(exact, options) {
    if (options === void 0) {
      options = {};
    }
    return new tsDecoders.Decoder(function(value) {
      return value === exact
        ? ok(value)
        : err(value, 'invalid value', 'must be ' + exact, 'exactlyD', options);
    });
  }

  /**
   * Accepts a javascript constructor argument (`class`) and creates a
   * decoder which verifies that its input is an `instanceof` the
   * provided constructor.
   */
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  function instanceOfD(clazz, options) {
    if (options === void 0) {
      options = {};
    }
    return new tsDecoders.Decoder(function(value) {
      return value instanceof clazz
        ? ok(value)
        : err(
            value,
            'invalid class',
            'must be an instance of ' + clazz.name,
            'instanceOfD',
            options,
          );
    });
  }

  /**
   * Can be used to verify that an unknown value is a whole `number`.
   *
   * Related:
   * - numberD
   * */
  function integerD(options) {
    if (options === void 0) {
      options = {};
    }
    return new tsDecoders.Decoder(function(value) {
      return Number.isInteger(value)
        ? ok(value)
        : err(
            value,
            'invalid type',
            'must be a whole number',
            'integerD',
            options,
          );
    });
  }

  function lazyD(decoderFn, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    if (options.promise) {
      return new tsDecoders.AsyncDecoder(function(value) {
        return __awaiter(_this, void 0, void 0, function() {
          var decoder;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                return [4 /*yield*/, decoderFn(value)];
              case 1:
                decoder = _a.sent();
                return [2 /*return*/, decoder.decode(value)];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(value) {
      return decoderFn(value).decode(value);
    });
  }

  var decoderName$5 = 'predicateD';
  var defaultMsg = 'failed custom check';
  function predicateD(fn, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    if (options.promise) {
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                return [4 /*yield*/, fn(input)];
              case 1:
                return [
                  2 /*return*/,
                  _a.sent()
                    ? ok(input)
                    : err(
                        input,
                        'failed check',
                        defaultMsg,
                        decoderName$5,
                        options,
                      ),
                ];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      return fn(input)
        ? ok(input)
        : err(input, 'failed check', defaultMsg, decoderName$5, options);
    });
  }

  var decoderName$6 = 'optionalD';
  var undefinedDecoder = exactlyD(undefined);
  var nullDecoder = exactlyD(null);
  function optionalD(decoder, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    if (decoder instanceof tsDecoders.AsyncDecoder) {
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var result;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                result = undefinedDecoder.decode(input);
                if (tsDecoders.isDecoderSuccess(result))
                  return [2 /*return*/, result];
                result = nullDecoder.decode(input);
                if (tsDecoders.isDecoderSuccess(result))
                  return [2 /*return*/, result];
                return [4 /*yield*/, decoder.decode(input)];
              case 1:
                result = _a.sent();
                if (tsDecoders.isDecoderSuccess(result))
                  return [2 /*return*/, result];
                return [
                  2 /*return*/,
                  applyOptionsToDecoderErrors(
                    input,
                    Array.from(result.values()).map(function(error) {
                      return new tsDecoders.DecoderError(
                        input,
                        'invalid type',
                        error.message + ' OR must be null OR must be undefined',
                        {
                          child: error,
                          decoderName: decoderName$6,
                        },
                      );
                    }),
                    options,
                  ),
                ];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      var result = undefinedDecoder.decode(input);
      if (tsDecoders.isDecoderSuccess(result)) return result;
      result = nullDecoder.decode(input);
      if (tsDecoders.isDecoderSuccess(result)) return result;
      result = decoder.decode(input);
      if (tsDecoders.isDecoderSuccess(result)) return result;
      return applyOptionsToDecoderErrors(
        input,
        Array.from(result.values()).map(function(error) {
          return new tsDecoders.DecoderError(
            input,
            'invalid type',
            error.message + ' OR must be null OR must be undefined',
            {
              child: error,
              decoderName: decoderName$6,
            },
          );
        }),
        options,
      );
    });
  }

  /**
   * Creates a decoder which always returns `DecoderError` with
   * whatever input value is provided to it.
   */
  function neverD(options) {
    if (options === void 0) {
      options = {};
    }
    return new tsDecoders.Decoder(function(value) {
      return err(value, 'forbidden', 'must not be present', 'neverD', options);
    });
  }

  var decoderName$7 = 'nullableD';
  var nullDecoder$1 = exactlyD(null);
  function nullableD(decoder, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    if (decoder instanceof tsDecoders.AsyncDecoder) {
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var result;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                result = nullDecoder$1.decode(input);
                if (tsDecoders.isDecoderSuccess(result))
                  return [2 /*return*/, result];
                return [4 /*yield*/, decoder.decode(input)];
              case 1:
                result = _a.sent();
                if (tsDecoders.isDecoderSuccess(result))
                  return [2 /*return*/, result];
                return [
                  2 /*return*/,
                  applyOptionsToDecoderErrors(
                    input,
                    Array.from(result.values()).map(function(error) {
                      return new tsDecoders.DecoderError(
                        input,
                        'invalid type',
                        error.message + ' OR must be null',
                        {
                          child: error,
                          decoderName: decoderName$7,
                        },
                      );
                    }),
                    options,
                  ),
                ];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      var result = nullDecoder$1.decode(input);
      if (tsDecoders.isDecoderSuccess(result)) return result;
      result = decoder.decode(input);
      if (tsDecoders.isDecoderSuccess(result)) return result;
      return applyOptionsToDecoderErrors(
        input,
        Array.from(result.values()).map(function(error) {
          return new tsDecoders.DecoderError(
            input,
            'invalid type',
            error.message + ' OR must be null',
            {
              child: error,
              decoderName: decoderName$7,
            },
          );
        }),
        options,
      );
    });
  }

  /**
   * Can be used to verify that an unknown value is a `number`.
   *
   * Related:
   * - integerD
   */
  function numberD(options) {
    if (options === void 0) {
      options = {};
    }
    return new tsDecoders.Decoder(function(value) {
      return Number.isFinite(value)
        ? ok(value)
        : err(value, 'invalid type', 'must be a number', 'numberD', options);
    });
  }

  var decoderName$8 = 'objectD';
  function nonObjectError$1(input, options) {
    return applyOptionsToDecoderErrors(
      input,
      [
        new tsDecoders.DecoderError(
          input,
          'invalid type',
          'must be a non-null object',
          {
            decoderName: decoderName$8,
          },
        ),
      ],
      options,
    );
  }
  function unknownKeyError(value, key) {
    return new tsDecoders.DecoderError(
      value,
      'unknown key',
      'unknown key ["' + key + '"]',
      {
        decoderName: decoderName$8,
        location: errorLocation(key, ''),
        key: key,
      },
    );
  }
  function fromChildError(child, value, key) {
    var type;
    var message;
    var location;
    var errorKey = key;
    if (value.hasOwnProperty(key)) {
      location = errorLocation(key, child.location);
      type = 'invalid key value';
      message = 'invalid value for key ["' + key + '"] > ' + child.message;
    } else {
      type = 'missing key';
      message = 'missing required key ["' + key + '"]';
      location = undefined;
      errorKey = undefined;
    }
    return new tsDecoders.DecoderError(value, type, message, {
      decoderName: decoderName$8,
      child: child,
      location: location,
      key: errorKey,
    });
  }
  function checkInputKeys(decoderObject, input, options) {
    var expectedkeys = Object.keys(decoderObject);
    var actualkeys = Object.keys(input);
    if (!options.allErrors) {
      var invalidKey = actualkeys.find(function(key) {
        return !expectedkeys.includes(key);
      });
      if (invalidKey !== undefined) {
        return [unknownKeyError(input, invalidKey)];
      }
    } else {
      var invalidKeys = actualkeys.filter(function(key) {
        return !expectedkeys.includes(key);
      });
      var errors = invalidKeys.map(function(key) {
        return unknownKeyError(input, key);
      });
      if (errors.length > 0) return errors;
    }
  }
  function objectD(decoderObject, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    var hasAsyncDecoder = Object.values(decoderObject).some(function(decoder) {
      return decoder instanceof tsDecoders.AsyncDecoder;
    });
    options = __assign({}, options, {
      decoderName: options.decoderName || decoderName$8,
    });
    if (hasAsyncDecoder) {
      if (options.allErrors) {
        return new tsDecoders.AsyncDecoder(function(input) {
          return __awaiter(_this, void 0, void 0, function() {
            var allErrors, invalidKeys, entries, resolvedEntries;
            var _this = this;
            return __generator(this, function(_a) {
              switch (_a.label) {
                case 0:
                  if (typeof input !== 'object' || input === null) {
                    return [2 /*return*/, nonObjectError$1(input, options)];
                  }
                  allErrors = [];
                  if (options.noExcessProperties) {
                    invalidKeys = checkInputKeys(decoderObject, input, options);
                    if (invalidKeys) {
                      allErrors.push.apply(allErrors, invalidKeys);
                    }
                  }
                  entries = Object.entries(decoderObject);
                  return [
                    4 /*yield*/,
                    Promise.all(
                      entries.map(
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        function(_a) {
                          var key = _a[0],
                            decoder = _a[1];
                          return __awaiter(_this, void 0, void 0, function() {
                            var value, result, errors;
                            return __generator(this, function(_b) {
                              switch (_b.label) {
                                case 0:
                                  value = input[key];
                                  return [4 /*yield*/, decoder.decode(value)];
                                case 1:
                                  result = _b.sent();
                                  if (tsDecoders.areDecoderErrors(result)) {
                                    errors = result.map(function(error) {
                                      return fromChildError(error, input, key);
                                    });
                                    allErrors.push.apply(allErrors, errors);
                                    return [2 /*return*/];
                                  }
                                  // eslint-disable-next-line @typescript-eslint/no-explicit-any
                                  return [2 /*return*/, [key, result.value]];
                              }
                            });
                          });
                        },
                      ),
                    ),
                  ];
                case 1:
                  resolvedEntries = _a.sent();
                  if (allErrors.length > 0) {
                    return [
                      2 /*return*/,
                      applyOptionsToDecoderErrors(input, allErrors, options),
                    ];
                  }
                  if (options.removeUndefinedProperties) {
                    resolvedEntries = resolvedEntries.filter(function(_a) {
                      var value = _a[1];
                      return value !== undefined;
                    });
                  }
                  return [
                    2 /*return*/,
                    ok(
                      // eslint-disable-next-line @typescript-eslint/no-explicit-any
                      Object.fromEntries(resolvedEntries),
                    ),
                  ];
              }
            });
          });
        });
      }
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var invalidKeys,
            entries,
            resultObj,
            _loop_1,
            _i,
            entries_1,
            _a,
            key,
            decoder,
            state_1;
          return __generator(this, function(_b) {
            switch (_b.label) {
              case 0:
                if (typeof input !== 'object' || input === null) {
                  return [2 /*return*/, nonObjectError$1(input, options)];
                }
                if (options.noExcessProperties) {
                  invalidKeys = checkInputKeys(decoderObject, input, options);
                  if (invalidKeys) {
                    return [
                      2 /*return*/,
                      applyOptionsToDecoderErrors(input, invalidKeys, options),
                    ];
                  }
                }
                entries = Object.entries(decoderObject);
                resultObj = {};
                _loop_1 = function(key, decoder) {
                  var value, result, errors;
                  return __generator(this, function(_a) {
                    switch (_a.label) {
                      case 0:
                        value = input[key];
                        return [4 /*yield*/, decoder.decode(value)];
                      case 1:
                        result = _a.sent();
                        if (tsDecoders.areDecoderErrors(result)) {
                          errors = result.map(function(error) {
                            return fromChildError(error, input, key);
                          });
                          return [
                            2 /*return*/,
                            {
                              value: applyOptionsToDecoderErrors(
                                input,
                                errors,
                                options,
                              ),
                            },
                          ];
                        }
                        if (
                          options.removeUndefinedProperties &&
                          result.value === undefined
                        ) {
                          return [2 /*return*/, 'continue'];
                        }
                        resultObj[key] = result.value;
                        return [2 /*return*/];
                    }
                  });
                };
                (_i = 0), (entries_1 = entries);
                _b.label = 1;
              case 1:
                if (!(_i < entries_1.length)) return [3 /*break*/, 4];
                (_a = entries_1[_i]), (key = _a[0]), (decoder = _a[1]);
                return [5 /*yield**/, _loop_1(key, decoder)];
              case 2:
                state_1 = _b.sent();
                if (typeof state_1 === 'object')
                  return [2 /*return*/, state_1.value];
                _b.label = 3;
              case 3:
                _i++;
                return [3 /*break*/, 1];
              case 4:
                return [2 /*return*/, ok(resultObj)];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      if (typeof input !== 'object' || input === null) {
        return nonObjectError$1(input, options);
      }
      var allErrors = [];
      if (options.noExcessProperties) {
        var invalidKeys = checkInputKeys(decoderObject, input, options);
        if (invalidKeys) {
          if (!options.allErrors) {
            return applyOptionsToDecoderErrors(input, invalidKeys, options);
          }
          allErrors.push.apply(allErrors, invalidKeys);
        }
      }
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      var entries = Object.entries(decoderObject);
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      var resultObj = {};
      var _loop_2 = function(key, decoder) {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        var value = input[key];
        var result = decoder.decode(value);
        if (tsDecoders.areDecoderErrors(result)) {
          var errors = result.map(function(error) {
            return fromChildError(error, input, key);
          });
          if (options.allErrors) {
            allErrors.push.apply(allErrors, errors);
            return 'continue';
          }
          return { value: applyOptionsToDecoderErrors(input, errors, options) };
        }
        if (options.removeUndefinedProperties && result.value === undefined) {
          return 'continue';
        }
        resultObj[key] = result.value;
      };
      for (var _i = 0, entries_2 = entries; _i < entries_2.length; _i++) {
        var _a = entries_2[_i],
          key = _a[0],
          decoder = _a[1];
        var state_2 = _loop_2(key, decoder);
        if (typeof state_2 === 'object') return state_2.value;
      }
      if (allErrors.length > 0) {
        return applyOptionsToDecoderErrors(input, allErrors, options);
      }
      return ok(resultObj);
    });
  }

  var decoderName$9 = 'undefinableD';
  var undefinedDecoder$1 = exactlyD(undefined);
  var errorsMapFn = function(input) {
    return function(error) {
      return new tsDecoders.DecoderError(
        input,
        'invalid type',
        error.message + ' OR must be undefined',
        {
          child: error,
          decoderName: decoderName$9,
        },
      );
    };
  };
  function undefinableD(decoder, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    if (decoder instanceof tsDecoders.AsyncDecoder) {
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var result;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                result = undefinedDecoder$1.decode(input);
                if (tsDecoders.isDecoderSuccess(result))
                  return [2 /*return*/, result];
                return [4 /*yield*/, decoder.decode(input)];
              case 1:
                result = _a.sent();
                if (tsDecoders.isDecoderSuccess(result))
                  return [2 /*return*/, result];
                return [
                  2 /*return*/,
                  applyOptionsToDecoderErrors(
                    input,
                    result.map(errorsMapFn(input)),
                    options,
                  ),
                ];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      var result = undefinedDecoder$1.decode(input);
      if (tsDecoders.isDecoderSuccess(result)) return result;
      result = decoder.decode(input);
      if (tsDecoders.isDecoderSuccess(result)) return result;
      return applyOptionsToDecoderErrors(
        input,
        result.map(errorsMapFn(input)),
        options,
      );
    });
  }

  /** Can be used to verify that an unknown value is a `string`. */
  function stringD(options) {
    if (options === void 0) {
      options = {};
    }
    return new tsDecoders.Decoder(function(value) {
      return typeof value === 'string'
        ? ok(value)
        : err(value, 'invalid type', 'must be a string', 'stringD', options);
    });
  }

  var decoderName$a = 'tupleD';
  function nonArrayError$1(input, options) {
    return err(
      input,
      'invalid type',
      'must be an array',
      decoderName$a,
      options,
    );
  }
  function invalidLengthError(length, input) {
    return new tsDecoders.DecoderError(
      input,
      'invalid length',
      'array must have length ' + length,
      {
        decoderName: decoderName$a,
      },
    );
  }
  function childError$1(child, value, key) {
    var location = errorLocation(key, child.location);
    return new tsDecoders.DecoderError(
      value,
      'invalid element',
      'invalid element [' + key + '] > ' + child.message,
      {
        decoderName: decoderName$a,
        child: child,
        location: location,
        key: key,
      },
    );
  }
  function tupleD(decoders, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    var hasAsyncDecoder = decoders.some(function(decoder) {
      return decoder instanceof tsDecoders.AsyncDecoder;
    });
    options = __assign({}, options, {
      decoderName: options.decoderName || decoderName$a,
    });
    if (hasAsyncDecoder) {
      if (options.allErrors) {
        return new tsDecoders.AsyncDecoder(function(input) {
          return __awaiter(_this, void 0, void 0, function() {
            var hasError, results, errors;
            var _this = this;
            return __generator(this, function(_a) {
              switch (_a.label) {
                case 0:
                  if (!Array.isArray(input)) {
                    return [2 /*return*/, nonArrayError$1(input, options)];
                  }
                  hasError = false;
                  return [
                    4 /*yield*/,
                    Promise.all(
                      decoders.map(function(decoder, index) {
                        return __awaiter(_this, void 0, void 0, function() {
                          var result;
                          return __generator(this, function(_a) {
                            switch (_a.label) {
                              case 0:
                                return [
                                  4 /*yield*/,
                                  decoder.decode(input[index]),
                                ];
                              case 1:
                                result = _a.sent();
                                if (tsDecoders.areDecoderErrors(result)) {
                                  hasError = true;
                                  return [
                                    2 /*return*/,
                                    result.map(function(error) {
                                      return childError$1(error, input, index);
                                    }),
                                  ];
                                }
                                return [2 /*return*/, result];
                            }
                          });
                        });
                      }),
                    ),
                  ];
                case 1:
                  results = _a.sent();
                  if (hasError || input.length !== decoders.length) {
                    errors = results
                      .filter(function(result) {
                        return Array.isArray(result);
                      })
                      .flat();
                    if (input.length !== decoders.length) {
                      errors.push(invalidLengthError(decoders.length, input));
                    }
                    return [
                      2 /*return*/,
                      applyOptionsToDecoderErrors(input, errors, options),
                    ];
                  }
                  return [
                    2 /*return*/,
                    ok(
                      results.map(function(result) {
                        return result.value;
                      }),
                    ),
                  ];
              }
            });
          });
        });
      }
      return new tsDecoders.AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var tuple, index, _i, decoders_1, decoder, result, errors;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                if (!Array.isArray(input)) {
                  return [2 /*return*/, nonArrayError$1(input, options)];
                } else if (input.length !== decoders.length) {
                  return [
                    2 /*return*/,
                    applyOptionsToDecoderErrors(
                      input,
                      invalidLengthError(decoders.length, input),
                      options,
                    ),
                  ];
                }
                tuple = [];
                index = -1;
                (_i = 0), (decoders_1 = decoders);
                _a.label = 1;
              case 1:
                if (!(_i < decoders_1.length)) return [3 /*break*/, 4];
                decoder = decoders_1[_i];
                index++;
                return [4 /*yield*/, decoder.decode(input[index])];
              case 2:
                result = _a.sent();
                if (tsDecoders.areDecoderErrors(result)) {
                  errors = result.map(function(error) {
                    return childError$1(error, input, index);
                  });
                  return [
                    2 /*return*/,
                    applyOptionsToDecoderErrors(input, errors, options),
                  ];
                }
                tuple.push(result.value);
                _a.label = 3;
              case 3:
                _i++;
                return [3 /*break*/, 1];
              case 4:
                return [2 /*return*/, ok(tuple)];
            }
          });
        });
      });
    }
    return new tsDecoders.Decoder(function(input) {
      if (!Array.isArray(input)) {
        return nonArrayError$1(input, options);
      }
      var tuple = [];
      var allErrors = [];
      var index = -1;
      if (input.length !== decoders.length) {
        if (!options.allErrors) {
          return applyOptionsToDecoderErrors(
            input,
            invalidLengthError(decoders.length, input),
            options,
          );
        }
        allErrors.push(invalidLengthError(decoders.length, input));
      }
      for (var _i = 0, decoders_2 = decoders; _i < decoders_2.length; _i++) {
        var decoder = decoders_2[_i];
        index++;
        var result = decoder.decode(input[index]);
        if (tsDecoders.areDecoderErrors(result)) {
          var errors = result.map(function(error) {
            return childError$1(error, input, index);
          });
          if (options.allErrors) {
            allErrors.push.apply(allErrors, errors);
            continue;
          }
          return applyOptionsToDecoderErrors(input, errors, options);
        }
        tuple.push(result.value);
      }
      if (allErrors.length > 0) {
        return applyOptionsToDecoderErrors(input, allErrors, options);
      }
      return ok(tuple);
    });
  }

  /** Can be used to verify that an unknown value is a uuid v4 `string`. */
  function uuidD(options) {
    if (options === void 0) {
      options = {};
    }
    return matchD(
      /[a-f0-9]{8}-[a-f0-9]{4}-4[a-f0-9]{3}-[89aAbB][a-f0-9]{3}-[a-f0-9]{12}/i,
      {
        data: options.data,
        decoderName: options.decoderName || 'uuidD',
        errorMsg: options.errorMsg || 'must be a v4 UUID',
      },
    );
  }

  exports.anyD = anyD;
  exports.anyOfD = anyOfD;
  exports.applyOptionsToDecoderErrors = applyOptionsToDecoderErrors;
  exports.arrayD = arrayD;
  exports.booleanD = booleanD;
  exports.chainOfD = chainOfD;
  exports.constantD = constantD;
  exports.dictionaryD = dictionaryD;
  exports.emailD = emailD;
  exports.exactlyD = exactlyD;
  exports.instanceOfD = instanceOfD;
  exports.integerD = integerD;
  exports.lazyD = lazyD;
  exports.matchD = matchD;
  exports.neverD = neverD;
  exports.nullableD = nullableD;
  exports.numberD = numberD;
  exports.objectD = objectD;
  exports.optionalD = optionalD;
  exports.predicateD = predicateD;
  exports.raceToDecoderSuccess = raceToDecoderSuccess;
  exports.stringD = stringD;
  exports.tupleD = tupleD;
  exports.undefinableD = undefinableD;
  exports.uuidD = uuidD;

  Object.defineProperty(exports, '__esModule', { value: true });
});
