(function(global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined'
    ? factory(exports)
    : typeof define === 'function' && define.amd
    ? define(['exports'], factory)
    : ((global = global || self), factory((global.tsDecoders = {})));
})(this, function(exports) {
  'use strict';

  /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
  /* global Reflect, Promise */

  var extendStatics = function(d, b) {
    extendStatics =
      Object.setPrototypeOf ||
      ({ __proto__: [] } instanceof Array &&
        function(d, b) {
          d.__proto__ = b;
        }) ||
      function(d, b) {
        for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
      };
    return extendStatics(d, b);
  };

  function __extends(d, b) {
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype =
      b === null ? Object.create(b) : ((__.prototype = b.prototype), new __());
  }

  function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function(resolve, reject) {
      function fulfilled(value) {
        try {
          step(generator.next(value));
        } catch (e) {
          reject(e);
        }
      }
      function rejected(value) {
        try {
          step(generator['throw'](value));
        } catch (e) {
          reject(e);
        }
      }
      function step(result) {
        result.done
          ? resolve(result.value)
          : new P(function(resolve) {
              resolve(result.value);
            }).then(fulfilled, rejected);
      }
      step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
  }

  function __generator(thisArg, body) {
    var _ = {
        label: 0,
        sent: function() {
          if (t[0] & 1) throw t[1];
          return t[1];
        },
        trys: [],
        ops: [],
      },
      f,
      y,
      t,
      g;
    return (
      (g = { next: verb(0), throw: verb(1), return: verb(2) }),
      typeof Symbol === 'function' &&
        (g[Symbol.iterator] = function() {
          return this;
        }),
      g
    );
    function verb(n) {
      return function(v) {
        return step([n, v]);
      };
    }
    function step(op) {
      if (f) throw new TypeError('Generator is already executing.');
      while (_)
        try {
          if (
            ((f = 1),
            y &&
              (t =
                op[0] & 2
                  ? y['return']
                  : op[0]
                  ? y['throw'] || ((t = y['return']) && t.call(y), 0)
                  : y.next) &&
              !(t = t.call(y, op[1])).done)
          )
            return t;
          if (((y = 0), t)) op = [op[0] & 2, t.value];
          switch (op[0]) {
            case 0:
            case 1:
              t = op;
              break;
            case 4:
              _.label++;
              return { value: op[1], done: false };
            case 5:
              _.label++;
              y = op[1];
              op = [0];
              continue;
            case 7:
              op = _.ops.pop();
              _.trys.pop();
              continue;
            default:
              if (
                !((t = _.trys), (t = t.length > 0 && t[t.length - 1])) &&
                (op[0] === 6 || op[0] === 2)
              ) {
                _ = 0;
                continue;
              }
              if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                _.label = op[1];
                break;
              }
              if (op[0] === 6 && _.label < t[1]) {
                _.label = t[1];
                t = op;
                break;
              }
              if (t && _.label < t[2]) {
                _.label = t[2];
                _.ops.push(op);
                break;
              }
              if (t[2]) _.ops.pop();
              _.trys.pop();
              continue;
          }
          op = body.call(thisArg, _);
        } catch (e) {
          op = [6, e];
          y = 0;
        } finally {
          f = t = 0;
        }
      if (op[0] & 5) throw op[1];
      return { value: op[0] ? op[1] : void 0, done: true };
    }
  }

  /**
   * DecoderSuccess returned on a successful call to
   * `Decoder#decode` or `AsyncDecoder#decode`
   */
  var DecoderSuccess = /** @class */ (function() {
    function DecoderSuccess(value) {
      this.value = value;
    }
    return DecoderSuccess;
  })();
  /**
   * DecoderError returned on a failed call to
   * `Decoder#decode` or `AsyncDecoder#decode`
   */
  var DecoderError = /** @class */ (function() {
    function DecoderError(
      /** The input that failed validation. */
      input,
      /** The type of error. e.g. "invalid type" */
      type,
      /** A human readable error message. e.g. "must be a string" */
      message,
      options,
    ) {
      if (options === void 0) {
        options = {};
      }
      this.input = input;
      this.type = type;
      this.message = message;
      this.decoderName = options.decoderName || '';
      this.location = options.location || '';
      this.child = options.child;
      this.key = options.key;
      this.data = options.data;
    }
    /**
     * Starting with this error, an array of the keys associated with
     * this error as well as all child errors.
     */
    DecoderError.prototype.path = function() {
      if (this.key === undefined) {
        if (!this.child) return [];
        return this.child.path();
      }
      if (!this.child) return [this.key];
      return [this.key].concat(this.child.path());
    };
    return DecoderError;
  })();
  function isDecoderSuccess(result) {
    return result instanceof DecoderSuccess;
  }
  function areDecoderErrors(result) {
    return Array.isArray(result);
  }

  function coerceDecodeFnResult(result) {
    return result instanceof DecoderError ? [result] : result;
  }
  /**
   * An object which can be used to validate and process `unknown` values
   * and cast them to the appropriate typescript type.
   *
   * @param decodeFn the function which is used to decode input values
   */
  var Decoder = /** @class */ (function() {
    function Decoder(decodeFn) {
      this.decodeFn = decodeFn;
    }
    Decoder.prototype.decode = function(input) {
      var _this = this;
      if (input instanceof Promise) {
        return input.then(function(res) {
          return coerceDecodeFnResult(_this.decodeFn(res));
        });
      }
      return coerceDecodeFnResult(this.decodeFn(input));
    };
    /**
     * On decode failure, handle the DecoderErrors.
     */
    Decoder.prototype.catch = function(fn) {
      var _this = this;
      return new Decoder(function(input) {
        var result = coerceDecodeFnResult(_this.decodeFn(input));
        if (areDecoderErrors(result)) {
          return fn(input, result);
        }
        return result;
      });
    };
    /**
     * On decode success, transform a value using the provided
     * transformation function.
     */
    Decoder.prototype.map = function(fn) {
      var _this = this;
      return new Decoder(function(input) {
        var result = _this.decodeFn(input);
        if (result instanceof DecoderSuccess) {
          return new DecoderSuccess(fn(result.value));
        }
        return result;
      });
    };
    Decoder.prototype.chain = function(a) {
      var _this = this;
      var fn = a instanceof Decoder ? a.decodeFn : a;
      return new Decoder(function(input) {
        var result = _this.decodeFn(input);
        if (result instanceof DecoderSuccess) {
          return fn(result.value);
        }
        return result;
      });
    };
    Decoder.prototype.toAsyncDecoder = function() {
      var _this = this;
      var fn = this.decodeFn;
      return new AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          return __generator(this, function(_a) {
            return [2 /*return*/, fn(input)];
          });
        });
      });
    };
    return Decoder;
  })();
  /**
   * An object which can be used to validate and process `unknown` values
   * and cast them to the appropriate typescript type. Unlike `Decoder`,
   * `AsyncDecoder` can receive a `decodeFn` which returns a promise.
   *
   * @param decodeFn the function which is used to decode input values
   */
  var AsyncDecoder = /** @class */ (function() {
    function AsyncDecoder(decodeFn) {
      this.decodeFn = decodeFn;
    }
    AsyncDecoder.prototype.decode = function(input) {
      return __awaiter(this, void 0, void 0, function() {
        var _a, _b;
        return __generator(this, function(_c) {
          switch (_c.label) {
            case 0:
              _a = coerceDecodeFnResult;
              _b = this.decodeFn;
              return [4 /*yield*/, input];
            case 1:
              return [4 /*yield*/, _b.apply(this, [_c.sent()])];
            case 2:
              return [2 /*return*/, _a.apply(void 0, [_c.sent()])];
          }
        });
      });
    };
    /**
     * On decode failure, handle the DecoderErrors.
     */
    AsyncDecoder.prototype.catch = function(fn) {
      var _this = this;
      return new AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var result, _a;
          return __generator(this, function(_b) {
            switch (_b.label) {
              case 0:
                _a = coerceDecodeFnResult;
                return [4 /*yield*/, this.decodeFn(input)];
              case 1:
                result = _a.apply(void 0, [_b.sent()]);
                if (areDecoderErrors(result)) {
                  return [2 /*return*/, fn(input, result)];
                }
                return [2 /*return*/, result];
            }
          });
        });
      });
    };
    /**
     * On decode success, transform a value using the provided
     * transformation function.
     */
    AsyncDecoder.prototype.map = function(fn) {
      var _this = this;
      return new AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var result, _a;
          return __generator(this, function(_b) {
            switch (_b.label) {
              case 0:
                return [4 /*yield*/, this.decodeFn(input)];
              case 1:
                result = _b.sent();
                if (!(result instanceof DecoderSuccess))
                  return [3 /*break*/, 3];
                _a = DecoderSuccess.bind;
                return [4 /*yield*/, fn(result.value)];
              case 2:
                return [
                  2 /*return*/,
                  new (_a.apply(DecoderSuccess, [void 0, _b.sent()]))(),
                ];
              case 3:
                return [2 /*return*/, result];
            }
          });
        });
      });
    };
    AsyncDecoder.prototype.chain = function(a) {
      var _this = this;
      var fn =
        a instanceof Decoder || a instanceof AsyncDecoder ? a.decodeFn : a;
      return new AsyncDecoder(function(input) {
        return __awaiter(_this, void 0, void 0, function() {
          var result;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                return [4 /*yield*/, this.decodeFn(input)];
              case 1:
                result = _a.sent();
                if (result instanceof DecoderSuccess) {
                  return [2 /*return*/, fn(result.value)];
                }
                return [2 /*return*/, result];
            }
          });
        });
      });
    };
    return AsyncDecoder;
  })();

  var AssertDecoderError = /** @class */ (function(_super) {
    __extends(AssertDecoderError, _super);
    function AssertDecoderError(errors) {
      var _this = _super.call(this) || this;
      _this.errors = errors;
      _this.name = 'AssertDecoderError';
      _this.message = errors
        .map(function(error) {
          return error.message;
        })
        .join(' \n');
      return _this;
    }
    return AssertDecoderError;
  })(Error);
  function handleResult(result) {
    if (areDecoderErrors(result)) throw new AssertDecoderError(result);
    return result.value;
  }
  function assert(decoder) {
    var _this = this;
    if (decoder instanceof AsyncDecoder) {
      return function(value) {
        return __awaiter(_this, void 0, void 0, function() {
          var _a, _b, _c;
          return __generator(this, function(_d) {
            switch (_d.label) {
              case 0:
                _a = handleResult;
                _c = (_b = decoder).decode;
                return [4 /*yield*/, value];
              case 1:
                return [4 /*yield*/, _c.apply(_b, [_d.sent()])];
              case 2:
                return [2 /*return*/, _a.apply(void 0, [_d.sent()])];
            }
          });
        });
      };
    }
    var decode = function(value) {
      return handleResult(decoder.decode(value));
    };
    // I have no idea how to explicitly type this return value
    // such that typescript does not complain
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return function(input) {
      return input instanceof Promise
        ? input.then(function(value) {
            return decode(value);
          })
        : decode(input);
    };
  }

  exports.AssertDecoderError = AssertDecoderError;
  exports.AsyncDecoder = AsyncDecoder;
  exports.Decoder = Decoder;
  exports.DecoderError = DecoderError;
  exports.DecoderSuccess = DecoderSuccess;
  exports.areDecoderErrors = areDecoderErrors;
  exports.assert = assert;
  exports.isDecoderSuccess = isDecoderSuccess;

  Object.defineProperty(exports, '__esModule', { value: true });
});
